type t = string

module Vars = struct
  module V = Set.Make
  (struct
    type t = string
    let compare = String.compare
  end)
  include V

  let of_list s = List.fold_right add s empty

  open Printf

  let print chan vs =
    let rec p_rec chan xs = match xs with
    | [] -> ()
    | [x] -> fprintf chan "%s" x
    | x::xs -> fprintf chan "%s, %a" x p_rec xs in
    fprintf chan "{%a}" p_rec (V.elements vs)

end
